from zona.models import Item
from pathlib import Path
import frontmatter
import os


def discover(root: str, out_dir: str) -> list[Item]:
    root_path = Path(root)
    required_dirs = {"content", "static", "templates"}
    found_dirs = {p.name for p in root_path.iterdir() if p.is_dir()}
    missing = required_dirs - found_dirs
    assert not missing, f"Missing required directories: {', '.join(missing)}"

    items: list[Item] = []

    for subdir in required_dirs:
        base = root_path / subdir
        for path in base.rglob("*"):
            if path.is_file():
                print(f"{subdir}: {path.relative_to(root_path)}")
                # TODO: build Item here
                # items.append(...)
    return items
